# Buildstream Rules for Bazel

These are experimental rules for building [Buildstream](https://gitlab.com/BuildStream/buildstream) projects via Bazel rules.

## Why?

Being able to build our toolchain with Buildstream for Bazel to consume would give us more control on what toolchain we use. More importantly it allows developers to leverage the strength of both clients in a single project.

## Docker

A Dockerfile with the required packages on Debian buster can be found in the [Crash project](https://gitlab.com/celduin/crash/docker-images/-/blob/master/dockerfiles/dockerfile.bob). This image can be pulled from "registry.gitlab.com/celduin/crash/docker-images/bob:latest".

## Usage

To use these rules, include the following in the workspace:

```
load("@bazel_tools//tools/build_defs/repo:git.bzl", "git_repository")
git_repository(
    name = "rules_buildstream",
    branch = "master",
    remote = "https://gitlab.com/celduin/buildstream-bazel/rules_buildstream.git",
)

load("@rules_buildstream//bst:defs.bzl", "bst_element")
```

Specific BuildStream elements to build and checkout can then be declared in the workspace:

```
bst_element(
    name = "my-bst-project",
    element = "hello.bst",
    project_dir = "/path/to/my-bst-project"
)
```

The external package exports a sequence of standard log files. These are named after the rule, the BuildStream subcommand and the type of log. The file name is `<name>_<subcommand>_<type>` where in this case name is `my-bst-project`, subcommand is either `build` or `checkout`, and type is either `stdout` or `stderr`. `hello.bst` can then be built by executing `bazel build @my-bst-project//:my-bst-project_checkout_stdout.log`. See the definition of [`bst_element`](./bst/defs.bzl) for a full list of optional parameters.

## Examples

### Autotools

To build the autotools example from the BuildStream project, a helper [script](examples/autotools/fetch-autotools) has been included:

```bash
pushd examples/autotools
./fetch-autotools
bazel build @test//:test_checkout_stdout.log
```

### Cipher-Shifter

Building the [cipher-shifter](https://gitlab.com/traveltissues/shift-cipher/-/tree/rules_buildstream) requires the declaration of a target `@bst//bst:libshift` which is the name parameter of a `cc_import` call. This target is generated by the [bazelize element](https://gitlab.com/BuildStream/bst-plugins-experimental/-/blob/master/src/bst_plugins_experimental/elements/bazelize.py) plugin of bst-plugins-experimental. You can build this example by executing:

```bash
pushd examples/e2e
./fetch-e2e
bazel build cipher-shifter
```
